Lattice Builder Manual Software Package for Constructing Rank-1 Lattices

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Friends Modules Pages
Public Types | Public Member Functions | List of all members
LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS > Class Template Reference

Evaluator for WeightedFigureOfMerit. More...

`#include <WeightedFigureOfMerit.h>`

## Public Types
typedef Storage< LAT, COMPRESS > ::MeritValue | MeritValue
typedef boost::signals2::signal< bool(const MeritValue &), Functor::AllOf > | OnProgress
typedef boost::signals2::signal< void(const LatDef< LAT > &)> | OnAbort

## Public Member Functions
| WeightedFigureOfMeritEvaluator (const FIGURE &figure, Storage< LAT, COMPRESS > storage)
| Constructor.
| WeightedFigureOfMeritEvaluator (WeightedFigureOfMeritEvaluator &&)=default
template<class CSETS >
MeritValue | operator() (const LatDef< LAT > &lat, const CSETS &projections, MeritValue initialValue) const
| Returns the square value of the figure of merit applied to the projections `projections` of the lattice `lat`. More...
Signals
OnProgress & | onProgress () const
| Progress signal. More...
OnAbort & | onAbort () const
| Abort signal. More...

## Detailed Description

### template<class FIGURE, LatType LAT, Compress COMPRESS>
class LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >

Evaluator for WeightedFigureOfMerit.

Using an evaluator allows for the WeightedFigureOfMerit object to be instantiated without prior knowledge of the storage class to be used during the evaluation.

## Member Function Documentation

template<class FIGURE , LatType LAT, Compress COMPRESS>

OnAbort& LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >::onAbort | ( |  | ) | const
| inline

Abort signal.

Emitted if the computation of the weighted figure of merit is aborted. The signal argument is the lattice definition for which the computation was aborted.

Referenced by LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >::operator()().

template<class FIGURE , LatType LAT, Compress COMPRESS>

OnProgress& LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >::onProgress | ( |  | ) | const
| inline

Progress signal.

Emitted after each projection-dependent contribution to the weighted figure of merit is processed. The signal argument is the cumulative value of the weighted figure of merit. If any of the signal slots returns `false`, the computation of the figure of merit will be aborted.

Referenced by LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >::operator()().

template<class FIGURE , LatType LAT, Compress COMPRESS>
template<class CSETS >

MeritValue LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >::operator() | ( | const LatDef< LAT > & | lat,
|  | const CSETS & | projections,
|  | MeritValue | initialValue
| ) |  | const
| inline

Returns the square value of the figure of merit applied to the projections `projections` of the lattice `lat`.

Parameters

  lat | Lattice for which the figure of merit will be computed.
  projections | Set of projections \(\mathcal J\) (see LatCommon::CoordinateSets).
  initialValue | Initial value to put in the accumulator.

References LatBuilder::LatDef< LAT >::dimension(), LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >::onAbort(), and LatBuilder::WeightedFigureOfMeritEvaluator< FIGURE, LAT, COMPRESS >::onProgress().

The documentation for this class was generated from the following file:

- latbuilder/include/latbuilder/WeightedFigureOfMerit.h